#!/usr/bin/env python

import md5, cPickle, ConfigParser, os, os.path, gdbm, re, sys
from optparse import OptionParser, OptionValueError


def main():
	if os.name != "posix":
		print "Not a supported platform. If you want to move archives from a POSIX platform to this platform, please do the conversion before moving."
		sys.exit(20)
	parser = OptionParser(usage="%prog <comicname>")
	(options, args) = parser.parse_args()
	comicsdir, comics = getConfig()
	comicslist = []
	if args == []:
		print "No comics specified, converting all in userlist."
		comicstoconvert = comics
	else:
		comicstoconvert = args
	for comic in comicstoconvert:
		if os.path.exists(comicsdir + comic):
			if os.path.isfile(comicsdir + comic + "/strips") and os.path.isfile(comicsdir + comic + "/stripurls.db"):
				comicslist.append(comic)
			else:
				print "Archive for %s is damaged, can not convert it." % comic
		else:
			print "Could not find archive for %s, not converting." % comic
	for comic in comicslist:
		print "Now converting stripsfile for %s." % comic
		dir = comicsdir + comic + "/"
		buildStripsDat(dir)


def getConfig():
	cfgdir = os.path.expanduser("~/.collector/")
	config = ConfigParser.ConfigParser()
	config.read(cfgdir + "collector.cfg")
	comicsdir = os.path.expanduser(config.get("Main", "comicsdir"))
	comics = config.get("Main", "comics").split(",")
	for i in range(len(comics)):
		comics[i] = comics[i].strip()
	if comicsdir[-1] != "/":
		comicsdir += "/"
	return comicsdir, comics


def buildStripsDat(dir):
	strips = open(dir + "strips", "r")
	stripurls = gdbm.open(dir + "stripurls.db", "r")
	data = ""
	for strip in strips:
		files = strip.split("|")
		try:
			data += stripurls[files[0].strip()]
		except:
			pass
		for file in files:
			file = file.strip()
			md5sum = md5.new()
			md5sum.update(open(dir + file, "r").read())
			data += "|" + file + "/" + md5sum.hexdigest()
		data += "\n"
	open(dir + "strips.dat", "w").write(data)


if __name__ == "__main__":
	main()
